---
title: How to document web errors
slug: MDN/Contribute/Howto/Document_web_errors
tags:
  - Howto
  - MDN
  - Meta
---
<div>{{MDNSidebar}}</div>

<p>The MDN <a href="/en-US/docs/Web/JavaScript/Reference/Errors">JavaScript error reference</a> is a new project aiming to help web developers with errors occurring in the <a href="/en-US/docs/Tools/Web_Console">Developer Console</a>.</p>

<p>You can see this feature in action in Firefox (Developer Edition). JavaScript errors contain a "Learn more" link that takes you to the JavaScript error reference containing additional advice for fixing issues.</p>

<p>{{EmbedYouTube("OabJc2QR6o0")}}</p>

<p>In order to help this project, we need to write more error documentation on MDN so that we can add more links to the tools where the messages are thrown.</p>

<h2 id="Prerequisites">Prerequisites</h2>

<ul>
 <li>You will need an <a href="/en-US/docs/MDN/Contribute/Howto/Create_an_MDN_account">MDN account</a>.</li>
 <li>You will need to know or able to dive into some <a href="/en-US/docs/Web/JavaScript">JavaScript</a>.</li>
</ul>

<h2 id="Step_1_–_find_an_error_to_document">Step 1 – find an error to document</h2>

<ul>
 <li>Firefox/Gecko's error messages: <a href="https://dxr.mozilla.org/mozilla-central/source/js/src/js.msg">https://dxr.mozilla.org/mozilla-central/source/js/src/js.msg</a></li>
 <li>Edge/Chakra's error messages: <a href="https://github.com/Microsoft/ChakraCore/blob/master/lib/Parser/rterrors.h">https://github.com/Microsoft/ChakraCore/blob/master/lib/Parser/rterrors.h</a></li>
 <li>Chrome/v8's error messages: <a href="https://github.com/v8/v8/blob/master/src/messages.h#L75">https://github.com/v8/v8/blob/master/src/messages.h#L75</a></li>
</ul>

<h2 id="Step_2_–_look_at_existing_error_docs">Step 2 – look at existing error docs</h2>

<ul>
 <li>Look at the existing <a href="/en-US/docs/Web/JavaScript/Reference/Errors">JavaScript error reference</a> and see how errors are documented.</li>
 <li>Depending on which type of error you want to write about, you can take a closer look at these pages.</li>
 <li>You might want to copy the content of an existing page to kick off your new page.</li>
</ul>

<h2 id="Step_3_–_create_a_new_page">Step 3 – create a new page</h2>

<ul>
 <li>All error pages live under this tree: <a href="/en-US/docs/Web/JavaScript/Reference/Errors">/docs/Web/JavaScript/Reference/Errors</a></li>
 <li>You can create a new subpage following <a href="/en-US/docs/new?parent=179598">this link</a>.</li>
</ul>

<h2 id="Step_4_–_write_some_content">Step 4 – write some content</h2>

<ul>
 <li>Either use a copied structure from one of the existing error documents or start from scratch. Your choice!</li>
 <li>You should have at least:
  <ul>
   <li>A syntax box containing the message as thrown in different browsers.</li>
   <li>The error type.</li>
   <li>A text that explains why this error happened, what its consequences are. Go beyond the thrown message.</li>
   <li>Examples showcasing the error (there might be more than one!) and an example showing how to fix the code.</li>
   <li>Pointers to other reference material on MDN.</li>
  </ul>
 </li>
</ul>
